package com.esotericsoftware.spine;

package ..deTemp.1731169598172;

import com.badlogic.gdx.files.FileHandle;
import com.badlogic.gdx.utils.Array;
import com.badlogic.gdx.utils.Json;
import com.badlogic.gdx.utils.JsonValue;
import com.badlogic.gdx.utils.JsonWriter;
import java.io.BufferedWriter;

public class JsonRollback {
  public static void main(String[] paramArrayOfString) throws Exception {
    if (paramArrayOfString.length != 2 && paramArrayOfString.length != 3) {
      System.out.println("Usage: <inputFile> <targetVersion> [outputFile]");
      System.exit(0);
    } 
    String str = paramArrayOfString[1];
    if (!str.equals("2.1") && !str.equals("3.7") && !str.equals("3.8")) {
      System.out.println("ERROR: Target version must be: 2.1, 3.7, or 3.8");
      System.out.println("Use the Spine editor JSON export to for versions 4.0+.");
      System.out.println("Usage: <inputFile> <toVersion> [outputFile]");
      System.exit(0);
    } 
    JsonValue jsonValue1 = (JsonValue)(new Json()).fromJson(null, new FileHandle(paramArrayOfString[0]));
    JsonValue jsonValue2 = jsonValue1.get("skeleton");
    if (jsonValue2 == null) {
      jsonValue2 = new JsonValue(JsonValue.ValueType.object);
      jsonValue2.name = "skeleton";
      JsonValue jsonValue = jsonValue1.child;
      jsonValue1.child = jsonValue2;
      jsonValue2.next = jsonValue;
    } 
    JsonValue jsonValue3 = jsonValue2.get("spine");
    if (jsonValue3 != null) {
      jsonValue3.set(str + "-from-" + jsonValue3.asString());
    } else {
      jsonValue2.addChild("spine", new JsonValue(str));
    } 
    if (str.equals("2.1")) {
      setValue(jsonValue1, "skinnedmesh", new String[] { "skins", "*", "*", "*", "type", "weightedmesh" });
      delete(jsonValue1, new String[] { "animations", "*", "bones", "*", "shear" });
      rename(jsonValue1, "ffd", new String[] { "animations", "*", "deform" });
      Array.ArrayIterator<JsonValue> arrayIterator;
      for (arrayIterator = find(jsonValue1, new Array(), 0, new String[] { "skins", "*", "*", "*", "type", "mesh" }).iterator(); arrayIterator.hasNext(); ) {
        JsonValue jsonValue4 = arrayIterator.next();
        if ((jsonValue4.parent.get("uvs")).size != (jsonValue4.parent.get("vertices")).size)
          jsonValue4.set("skinnedmesh"); 
      } 
      for (arrayIterator = find(jsonValue1, new Array(), 0, new String[] { "skins", "*", "*", "*", "type", "linkedmesh" }).iterator(); arrayIterator.hasNext(); ) {
        JsonValue jsonValue4 = arrayIterator.next();
        String str1 = jsonValue4.parent.parent.name.replaceAll("", "");
        String str2 = jsonValue4.parent.getString("skin", "default");
        String str3 = jsonValue4.parent.getString("parent");
        if ((find(jsonValue1, new Array(), 0, ("skins~~" + str2 + "~~" + str1 + "~~" + str3 + "~~type~~skinnedmesh")
            .split("~~"))).size > 0)
          jsonValue4.set("weightedlinkedmesh"); 
      } 
      for (arrayIterator = find(jsonValue1, new Array(), 0, new String[] { "skins", "*", "*", "*", "type", "boundingbox" }).iterator(); arrayIterator.hasNext(); ) {
        JsonValue jsonValue4 = arrayIterator.next();
        if (jsonValue4.parent.getInt("vertexCount") * 2 != (jsonValue4.parent.get("vertices")).size)
          jsonValue4.parent.parent.remove(jsonValue4.parent.name); 
      } 
      for (arrayIterator = find(jsonValue1, new Array(), 0, new String[] { "skins", "*", "*", "*", "type", "path" }).iterator(); arrayIterator.hasNext(); ) {
        JsonValue jsonValue4 = arrayIterator.next();
        String str1 = jsonValue4.parent.name;
        jsonValue4.parent.parent.remove(str1);
        String str2 = jsonValue4.parent.parent.name;
        delete(jsonValue1, new String[] { "animations", "*", "ffd", "*", str2, str1 });
      } 
      for (arrayIterator = find(jsonValue1, new Array(), 0, new String[] { "animations", "*", "ik", "*" }).iterator(); arrayIterator.hasNext(); ) {
        JsonValue jsonValue4 = arrayIterator.next();
        for (JsonValue jsonValue5 = jsonValue4.child; jsonValue5 != null; jsonValue5 = jsonValue5.next) {
          if (!jsonValue5.has("bendPositive"))
            jsonValue5.addChild("bendPositive", new JsonValue(true)); 
        } 
      } 
      for (JsonValue jsonValue = jsonValue1.getChild("transform"); jsonValue != null; jsonValue = jsonValue.next) {
        JsonValue jsonValue4 = jsonValue.remove("bones");
        if (jsonValue4 != null)
          jsonValue.addChild("bone", new JsonValue(jsonValue4.child.asString())); 
      } 
    } else if (str.equals("3.7")) {
      JsonValue jsonValue = jsonValue1.get("skins");
      if (jsonValue != null && jsonValue.isArray()) {
        JsonValue jsonValue4 = new JsonValue(JsonValue.ValueType.object);
        for (JsonValue jsonValue5 = jsonValue.child; jsonValue5 != null; jsonValue5 = jsonValue5.next) {
          JsonValue jsonValue6 = jsonValue5.get("attachments");
          if (jsonValue6 != null)
            jsonValue4.addChild(jsonValue5.getString("name"), jsonValue5.get("attachments")); 
        } 
        jsonValue1.remove("skins");
        jsonValue1.addChild("skins", jsonValue4);
      } 
      rollbackCurves(jsonValue1.get("animations"));
    } else if (str.equals("3.8")) {
      linearCurves(jsonValue1.get("animations"));
      rename(jsonValue1, "angle", new String[] { "animations", "*", "bones", "*", "rotate", "value" });
      constraintNames(jsonValue1, new String[] { "transform" });
      constraintNames(jsonValue1, new String[] { "path" });
      constraintNames(jsonValue1, new String[] { "animations", "*", "transform", "*" });
      constraintNames(jsonValue1, new String[] { "animations", "*", "path", "*" });
    } 
    if (paramArrayOfString.length == 3) {
      System.out.println("Writing: " + paramArrayOfString[2]);
      BufferedWriter bufferedWriter = new BufferedWriter((new FileHandle(paramArrayOfString[2])).writer(false, "UTF-8"), 16384);
      jsonValue1.prettyPrint(JsonWriter.OutputType.json, bufferedWriter);
      bufferedWriter.close();
    } else {
      System.out.println(jsonValue1.prettyPrint(JsonWriter.OutputType.json, 130));
    } 
  }
  
  private static void log(String paramString) {
    System.out.println(paramString);
  }
  
  private static void constraintNames(JsonValue paramJsonValue, String... paramVarArgs) {
    for (Array.ArrayIterator<JsonValue> arrayIterator = find(paramJsonValue, new Array(), 0, paramVarArgs).iterator(); arrayIterator.hasNext(); ) {
      JsonValue jsonValue1 = arrayIterator.next();
      for (JsonValue jsonValue2 = jsonValue1.child; jsonValue2 != null; jsonValue2 = jsonValue2.next) {
        for (JsonValue jsonValue = jsonValue2.child; jsonValue != null; jsonValue = jsonValue.next) {
          if (jsonValue.name.equals("mixRotate")) {
            jsonValue.name = "rotateMix";
          } else if (jsonValue.name.equals("mixX") || jsonValue.name.equals("mixY")) {
            jsonValue.name = "translateMix";
          } else if (jsonValue.name.equals("mixScaleX") || jsonValue.name.equals("mixScaleY")) {
            jsonValue.name = "scaleMix";
          } else if (jsonValue.name.equals("mixShearX") || jsonValue.name.equals("mixShearY")) {
            jsonValue.name = "shearMix";
          } 
        } 
      } 
    } 
  }
  
  private static void linearCurves(JsonValue paramJsonValue) {
    if (paramJsonValue == null)
      return; 
    if (paramJsonValue.isObject() && paramJsonValue.parent.isArray() && 
      paramJsonValue.parent.name != null) {
      String str = paramJsonValue.parent.name;
      if (str.equals("translatex") || str.equals("translatey") || str
        .equals("scalex") || str.equals("scaley") || str
        .equals("shearx") || str.equals("sheary") || str
        .equals("rgb") || str.equals("rgb2") || str.equals("alpha")) {
        paramJsonValue.parent.remove();
        log("Separate timelines removed: " + str);
      } 
      if (str.equals("rgba")) {
        paramJsonValue.parent.name = "color";
      } else if (str.equals("rgba2")) {
        paramJsonValue.parent.name = "twoColor";
      } 
    } 
    JsonValue jsonValue = paramJsonValue.get("curve");
    if (jsonValue == null) {
      for (JsonValue jsonValue1 = paramJsonValue.child; jsonValue1 != null; jsonValue1 = jsonValue1.next)
        linearCurves(jsonValue1); 
      return;
    } 
    if (!jsonValue.isString()) {
      jsonValue.remove();
      log("Bezier curve changed to linear.");
    } 
  }
  
  private static void rollbackCurves(JsonValue paramJsonValue) {
    if (paramJsonValue == null)
      return; 
    if (paramJsonValue.isObject() && paramJsonValue.parent.isArray()) {
      if (!paramJsonValue.has("time"))
        paramJsonValue.addChild("time", new JsonValue(0.0D)); 
      if (paramJsonValue.parent.name != null)
        if (paramJsonValue.parent.name.equals("rotate") && !paramJsonValue.has("angle")) {
          paramJsonValue.addChild("angle", new JsonValue(0.0D));
        } else if (paramJsonValue.parent.name.equals("scale")) {
          if (!paramJsonValue.has("x"))
            paramJsonValue.addChild("x", new JsonValue(1.0D)); 
          if (!paramJsonValue.has("y"))
            paramJsonValue.addChild("y", new JsonValue(1.0D)); 
        }  
    } 
    JsonValue jsonValue = paramJsonValue.get("curve");
    if (jsonValue == null) {
      for (JsonValue jsonValue1 = paramJsonValue.child; jsonValue1 != null; jsonValue1 = jsonValue1.next)
        rollbackCurves(jsonValue1); 
      return;
    } 
    if (jsonValue.isNumber()) {
      jsonValue.addChild(new JsonValue(jsonValue.asFloat()));
      jsonValue.setType(JsonValue.ValueType.array);
      jsonValue.addChild(new JsonValue(paramJsonValue.getFloat("c2", 0.0F)));
      jsonValue.addChild(new JsonValue(paramJsonValue.getFloat("c3", 1.0F)));
      jsonValue.addChild(new JsonValue(paramJsonValue.getFloat("c4", 1.0F)));
      paramJsonValue.remove("c2");
      paramJsonValue.remove("c3");
      paramJsonValue.remove("c4");
    } 
  }
  
  static void setValue(JsonValue paramJsonValue, String paramString, String... paramVarArgs) {
    for (Array.ArrayIterator<JsonValue> arrayIterator = find(paramJsonValue, new Array(), 0, paramVarArgs).iterator(); arrayIterator.hasNext(); ) {
      JsonValue jsonValue = arrayIterator.next();
      jsonValue.set(paramString);
    } 
  }
  
  static void rename(JsonValue paramJsonValue, String paramString, String... paramVarArgs) {
    for (Array.ArrayIterator<JsonValue> arrayIterator = find(paramJsonValue, new Array(), 0, paramVarArgs).iterator(); arrayIterator.hasNext(); ) {
      JsonValue jsonValue = arrayIterator.next();
      jsonValue.name = paramString;
    } 
  }
  
  static void delete(JsonValue paramJsonValue, String... paramVarArgs) {
    for (Array.ArrayIterator<JsonValue> arrayIterator = find(paramJsonValue, new Array(), 0, paramVarArgs).iterator(); arrayIterator.hasNext(); ) {
      JsonValue jsonValue = arrayIterator.next();
      jsonValue.parent.remove(jsonValue.name);
    } 
  }
  
  static Array<JsonValue> find(JsonValue paramJsonValue, Array<JsonValue> paramArray, int paramInt, String... paramVarArgs) {
    String str = paramVarArgs[paramInt];
    if (paramJsonValue.name == null) {
      if (str.equals("*") && paramInt == paramVarArgs.length - 1) {
        paramArray.add(paramJsonValue);
      } else if (paramJsonValue.has(str)) {
        return find(paramJsonValue.get(str), paramArray, paramInt, paramVarArgs);
      } 
    } else if (str.equals("*") || paramJsonValue.name.equals(str)) {
      if (++paramInt == paramVarArgs.length || (paramInt == paramVarArgs.length - 1 && paramJsonValue.isString() && paramJsonValue.asString().equals(paramVarArgs[paramInt]))) {
        paramArray.add(paramJsonValue);
      } else {
        for (JsonValue jsonValue = paramJsonValue.child; jsonValue != null; jsonValue = jsonValue.next)
          find(jsonValue, paramArray, paramInt, paramVarArgs); 
      } 
    } 
    return paramArray;
  }
}
